#pragma once

#include "DblScope.h"

#define IDC_TOOLBAR			16127
#define IDC_TOOLBARBUTTON	16129

//#define USE_TEXTURE

// CMuleToolbarCtrl

class CMuleToolbarCtrl : public CToolBarCtrl
{
	DECLARE_DYNAMIC(CMuleToolbarCtrl)

public:
	CMuleToolbarCtrl();
	virtual ~CMuleToolbarCtrl();

protected:
	CDblScope m_ctrlSpeedMeter;
	bool 	m_bUseSpeedMeter;
	
	int	m_iLastPressedButton;
	TBBUTTON TBButtons[9];
	char TBStrings[9][200];
	CStringArray bitmappaths;
	int m_iToolbarLabelSettings;
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnSize(UINT nType, int cx, int cy);

	void Init(void);
	void Localize(void);
	afx_msg void OnNMRclick(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTbnQueryDelete(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTbnQueryInsert(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTbnGetButtonInfo(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTbnToolbarChange(NMHDR *pNMHDR, LRESULT *pResult);
	void SetSpeedMeterValues(int iValue1, int iValue2)
	{
		m_ctrlSpeedMeter.AddValues(iValue1,iValue2);
	}
	void SetSpeedMeterRange(UINT nMax, UINT nMin)
	{
		m_ctrlSpeedMeter.SetRange(nMin, nMax);
	}
	void GetSpeedMeterRange(UINT& nMax, UINT& nMin)
	{
		m_ctrlSpeedMeter.GetRange(nMax, nMin);
	}
	void ShowSpeedMeter(bool bShow = true);
	void SetBtnWidth();

	// Customization might splits up the button-group, so we have to (un-)press them on our own
	void PressMuleButton(int nID)
	{
		if(m_iLastPressedButton != -1)
			CheckButton(m_iLastPressedButton, FALSE);
		CheckButton(nID, TRUE);
		m_iLastPressedButton = nID;
	}
	// [FoRcHa]
	void ChangeToolbarBitmap(CString path, bool refresh);
	void ChangeTextLabelStyle(int settings, bool refresh);
	void Refresh();
};


