// PPgAdvanced.cpp : implementation file

#include "stdafx.h"
#include "emule.h"
#include "PPgAdvanced.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgAdvanced dialog

IMPLEMENT_DYNAMIC(CPPgAdvanced, CPropertyPage)
CPPgAdvanced::CPPgAdvanced()
	: CPropertyPage(CPPgAdvanced::IDD)
{
}

CPPgAdvanced::~CPPgAdvanced()
{
}

void CPPgAdvanced::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_NS_DAY_TIME, m_nsdtime); // DonGato
	DDX_Control(pDX, IDC_NS_NIGHT_TIME, m_nsntime); // DonGato
}

BEGIN_MESSAGE_MAP(CPPgAdvanced, CPropertyPage)
	ON_EN_CHANGE(IDC_BANTIMES, OnSettingsChange)
	ON_EN_CHANGE(IDC_MINREQUESTTIME, OnSettingsChange)
	ON_EN_CHANGE(IDC_BANTIMEINMINS, OnSettingsChange)
	ON_BN_CLICKED(IDC_BANMESSAGE, OnSettingsChange)
	ON_BN_CLICKED(IDC_COMENABLED, OnBnClickedComEnabled)
	ON_EN_CHANGE(IDC_COMSTRING, OnSettingsChange)
	ON_BN_CLICKED(IDC_NOBANENABLED, OnSettingsChange)
	ON_EN_CHANGE(IDC_RESTORE_SOURCES_TIME, OnSettingsChange)
	ON_EN_CHANGE(IDC_LOAD_QUANTITIES, OnSettingsChange)
	ON_EN_CHANGE(IDC_OUTDATED, OnSettingsChange)
	ON_BN_CLICKED(IDC_SLSENABLED, OnBnClickedSLSEnabled)
	ON_BN_CLICKED(IDC_MLDONKEY_CM, OnSettingsChange)
	ON_BN_CLICKED(IDC_NS_ENABLED, OnBnClickedNSEnabled)
	ON_CBN_SELCHANGE(IDC_NS_DAY_TIME, OnCbnSelchangeDayTime)
	ON_CBN_SELCHANGE(IDC_NS_NIGHT_TIME, OnCbnSelchangeNightTime)
	ON_EN_CHANGE(IDC_NS_DAY_UP, OnSettingsChange)
	ON_EN_CHANGE(IDC_NS_DAY_DOWN, OnSettingsChange)
	ON_EN_CHANGE(IDC_NS_NIGHT_UP, OnSettingsChange)
	ON_EN_CHANGE(IDC_NS_NIGHT_DOWN, OnSettingsChange)
	ON_BN_CLICKED(IDC_NS_EXCEPT, OnSettingsChange)
	ON_BN_CLICKED(IDC_NS_EXCEPT_SAT, OnSettingsChange)
	ON_BN_CLICKED(IDC_NS_EXCEPT_SUN, OnSettingsChange)
END_MESSAGE_MAP()

BOOL CPPgAdvanced::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_nsdtime.SetItemData(m_nsdtime.AddString("6:00"),21600);
	m_nsdtime.SetItemData(m_nsdtime.AddString("6:30"),23400);
	m_nsdtime.SetItemData(m_nsdtime.AddString("7:00"),25200);
	m_nsdtime.SetItemData(m_nsdtime.AddString("7:30"),27000);
	m_nsdtime.SetItemData(m_nsdtime.AddString("8:00"),28800);
	m_nsdtime.SetItemData(m_nsdtime.AddString("8:30"),30600);
	m_nsdtime.SetItemData(m_nsdtime.AddString("9:00"),32400);
	m_nsdtime.SetItemData(m_nsdtime.AddString("9:30"),34200);
	m_nsdtime.SetItemData(m_nsdtime.AddString("10:00"),36000);
	m_nsdtime.SetItemData(m_nsdtime.AddString("10:30"),37800);
	m_nsdtime.SetItemData(m_nsdtime.AddString("11:00"),39600);
	m_nsdtime.SetItemData(m_nsdtime.AddString("11:30"),41400);
	m_nsdtime.SetItemData(m_nsdtime.AddString("12:00"),43200);
	m_nsdtime.SetItemData(m_nsdtime.AddString("12:30"),45000);

	m_nsntime.SetItemData(m_nsntime.AddString("17:00"),61200);
	m_nsntime.SetItemData(m_nsntime.AddString("17:30"),63000);
	m_nsntime.SetItemData(m_nsntime.AddString("18:00"),64800);
	m_nsntime.SetItemData(m_nsntime.AddString("18:30"),66600);
	m_nsntime.SetItemData(m_nsntime.AddString("19:00"),68400);
	m_nsntime.SetItemData(m_nsntime.AddString("19:30"),70200);
	m_nsntime.SetItemData(m_nsntime.AddString("20:00"),72000);
	m_nsntime.SetItemData(m_nsntime.AddString("20:30"),73800);
	m_nsntime.SetItemData(m_nsntime.AddString("21:00"),75600);
	m_nsntime.SetItemData(m_nsntime.AddString("21:30"),77400);
	m_nsntime.SetItemData(m_nsntime.AddString("22:00"),79200);
	m_nsntime.SetItemData(m_nsntime.AddString("22:30"),81000);
	m_nsntime.SetItemData(m_nsntime.AddString("23:00"),82800);
	m_nsntime.SetItemData(m_nsntime.AddString("23:30"),84600);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgAdvanced::LoadSettings(void)
{
	char buffer[200];
	sprintf(buffer,"%d", app_prefs->BadClientMinRequestNum());
	GetDlgItem(IDC_BANTIMES)->SetWindowText(buffer);
	sprintf(buffer,"%d", app_prefs->BadClientBanTime()/60000);
	GetDlgItem(IDC_BANTIMEINMINS)->SetWindowText(buffer);

	CastSecondsToHM(app_prefs->BadClientMinRequestTime()/1000,buffer,5);
	GetDlgItem(IDC_MINREQUESTTIME)->SetWindowText(buffer);

	if (app_prefs->IsBanMessageEnabled()) 
		CheckDlgButton(IDC_BANMESSAGE,1);
	else
		CheckDlgButton(IDC_BANMESSAGE,0);

	GetDlgItem(IDC_COMSTRING)->SetWindowText(app_prefs->CommunityString());
	if(app_prefs->CommunityEnabled())
		CheckDlgButton(IDC_COMENABLED,1);
	else
		CheckDlgButton(IDC_COMENABLED,0);
	if(app_prefs->CommunityNoBanEnabled())
		CheckDlgButton(IDC_NOBANENABLED,1);
	else
		CheckDlgButton(IDC_NOBANENABLED,0);
	OnBnClickedComEnabled();

	sprintf(buffer,"%d", app_prefs->RestoreSourcesTime()/60000);
	GetDlgItem(IDC_RESTORE_SOURCES_TIME)->SetWindowText(buffer);
	sprintf(buffer,"%d", app_prefs->LoadQuantities());
	GetDlgItem(IDC_LOAD_QUANTITIES)->SetWindowText(buffer);
	sprintf(buffer,"%d", app_prefs->WhenSourcesOutdated());
	GetDlgItem(IDC_OUTDATED)->SetWindowText(buffer);
	if(app_prefs->SLSEnable())
		CheckDlgButton(IDC_SLSENABLED,1);
	else
		CheckDlgButton(IDC_SLSENABLED,0);
	OnBnClickedSLSEnabled();

	for(int i = 0; i != m_nsdtime.GetCount(); i++)
		if(m_nsdtime.GetItemData(i) == app_prefs->GetNSEnd())
			m_nsdtime.SetCurSel(i);

	for(int i = 0; i != m_nsntime.GetCount(); i++)
		if(m_nsntime.GetItemData(i) == app_prefs->GetNSStart())
			m_nsntime.SetCurSel(i);

	if(app_prefs->GetNSDayUpload() == 0xFFFF)
		GetDlgItem(IDC_NS_DAY_UP)->SetWindowText("0");
	else
	{
		sprintf(buffer,"%d", app_prefs->GetNSDayUpload());
		GetDlgItem(IDC_NS_DAY_UP)->SetWindowText(buffer);
	}
	if(app_prefs->GetNSDayDownload() == 0xFFFF)
		GetDlgItem(IDC_NS_DAY_DOWN)->SetWindowText("0");
	else
	{
		sprintf(buffer,"%d", app_prefs->GetNSDayDownload());
		GetDlgItem(IDC_NS_DAY_DOWN)->SetWindowText(buffer);
	}

	if(app_prefs->GetNSNightUpload() == 0xFFFF)
		GetDlgItem(IDC_NS_NIGHT_UP)->SetWindowText("0");
	else
	{
		sprintf(buffer,"%d", app_prefs->GetNSNightUpload());
		GetDlgItem(IDC_NS_NIGHT_UP)->SetWindowText(buffer);
	}
	if(app_prefs->GetNSNightDownload() == 0xFFFF)
		GetDlgItem(IDC_NS_NIGHT_DOWN)->SetWindowText("0");
	else
	{
		sprintf(buffer,"%d", app_prefs->GetNSNightDownload());
		GetDlgItem(IDC_NS_NIGHT_DOWN)->SetWindowText(buffer);
	}

	if(app_prefs->IsNSExceptSat())
		CheckDlgButton(IDC_NS_EXCEPT_SAT,1);
	else
		CheckDlgButton(IDC_NS_EXCEPT_SAT,0);
	if(app_prefs->IsNSExceptSun())
		CheckDlgButton(IDC_NS_EXCEPT_SUN,1);
	else
		CheckDlgButton(IDC_NS_EXCEPT_SUN,0);

	if(app_prefs->IsNSEnabled())
		CheckDlgButton(IDC_NS_ENABLED,1);
	else
		CheckDlgButton(IDC_NS_ENABLED,0);
	OnBnClickedNSEnabled();

	if(app_prefs->GetMlDonkeyCM())
		CheckDlgButton(IDC_MLDONKEY_CM,1);
	else
		CheckDlgButton(IDC_MLDONKEY_CM,0);

	SetModified(FALSE);
}

BOOL CPPgAdvanced::OnApply()
{	
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		char buffer[200];
		int iTmp;

		GetDlgItem(IDC_BANTIMES)->GetWindowText(buffer,3);
		app_prefs->SetBadClientMinRequestNum(atoi(buffer));
		if(app_prefs->BadClientMinRequestNum() < 3)
			app_prefs->SetBadClientMinRequestNum(3);
		if(app_prefs->BadClientMinRequestNum() >10)
			app_prefs->SetBadClientMinRequestNum(10);

		sprintf(buffer, "%d",app_prefs->BadClientMinRequestNum());
		GetDlgItem(IDC_BANTIMES)->SetWindowText(buffer);

		GetDlgItem(IDC_BANTIMEINMINS)->GetWindowText(buffer,6);
		app_prefs->SetBadClientBanTime(atoi(buffer)*60000);
		if(app_prefs->BadClientBanTime() > 18000000)
			app_prefs->SetBadClientBanTime(18000000);
		if(app_prefs->BadClientBanTime() < 1800000)
			app_prefs->SetBadClientBanTime(1800000);

		sprintf(buffer, "%d",app_prefs->BadClientBanTime()/60000);
		GetDlgItem(IDC_BANTIMEINMINS)->SetWindowText(buffer);

		app_prefs->SetBanMessageEnabled(IsDlgButtonChecked(IDC_BANMESSAGE));

		GetDlgItem(IDC_MINREQUESTTIME)->GetWindowText(buffer,6);
		CString strBuffer;
		strBuffer=buffer;
		strBuffer.Replace(":",".");
		iTmp=(atof(strBuffer)-(float)atoi(strBuffer))*100.0f+0.5;
		if (iTmp>59) iTmp=59;
		app_prefs->SetBadClientMinRequestTime(atoi(strBuffer)*60000 +iTmp *1000);
		if(app_prefs->BadClientMinRequestTime() > 590000)
			app_prefs->SetBadClientMinRequestTime(590000);
		if(app_prefs->BadClientMinRequestTime() < 120000)
			app_prefs->SetBadClientMinRequestTime(120000);		
		CastSecondsToHM(app_prefs->BadClientMinRequestTime()/1000,buffer,5);		//Cax2 terminate the string after the seconds...
		GetDlgItem(IDC_MINREQUESTTIME)->SetWindowText(buffer);

		GetDlgItem(IDC_COMSTRING)->GetWindowText(buffer,100);
		app_prefs->SetCommunityString(buffer);
		app_prefs->SetCommunityEnabled((int8)IsDlgButtonChecked(IDC_COMENABLED));
		app_prefs->SetCommunityNoBanEnabled((int8)IsDlgButtonChecked(IDC_NOBANENABLED));
	
		GetDlgItem(IDC_RESTORE_SOURCES_TIME)->GetWindowText(buffer,8);
		app_prefs->SetRestoreSourcesTime(atoi(buffer)*60000);
		if(app_prefs->RestoreSourcesTime() < 3600000){
			app_prefs->SetRestoreSourcesTime( 3600000);
			sprintf(buffer, "%d",app_prefs->RestoreSourcesTime()/60000);
			GetDlgItem(IDC_RESTORE_SOURCES_TIME)->SetWindowText(buffer);
		}
		GetDlgItem(IDC_LOAD_QUANTITIES)->GetWindowText(buffer,8);
		app_prefs->SetLoadQuantities(atoi(buffer));
		if(app_prefs->LoadQuantities() > 100){
			app_prefs->SetLoadQuantities(100);
			sprintf(buffer, "%d",app_prefs->LoadQuantities());
			GetDlgItem(IDC_LOAD_QUANTITIES)->SetWindowText(buffer);
		}
		GetDlgItem(IDC_OUTDATED)->GetWindowText(buffer,3);
		app_prefs->SetWhenSourcesOutdated(atoi(buffer));
		if(app_prefs->WhenSourcesOutdated() > 10){
			app_prefs->SetWhenSourcesOutdated(10);
			sprintf(buffer, "%d",app_prefs->WhenSourcesOutdated());
			GetDlgItem(IDC_OUTDATED)->SetWindowText(buffer);
		}
		app_prefs->SetSLSEnable((int8)IsDlgButtonChecked(IDC_SLSENABLED));

		if(GetDlgItem(IDC_NS_DAY_UP)->GetWindowTextLength())
		{
			GetDlgItem(IDC_NS_DAY_UP)->GetWindowText(buffer,20);
			app_prefs->SetNSDayUpload((atoi(buffer)) ? atoi(buffer) : 0xFFFF);
		}
		if(GetDlgItem(IDC_NS_DAY_DOWN)->GetWindowTextLength())
		{
			GetDlgItem(IDC_NS_DAY_DOWN)->GetWindowText(buffer,20);
			app_prefs->SetNSDayDownload((atoi(buffer)) ? atoi(buffer) : 0xFFFF);
		}
		theApp.uploadqueue->NSDayUploadCheck();

		if(GetDlgItem(IDC_NS_NIGHT_UP)->GetWindowTextLength())
		{
			GetDlgItem(IDC_NS_NIGHT_UP)->GetWindowText(buffer,20);
			app_prefs->SetNSNightUpload((atoi(buffer)) ? atoi(buffer) : 0xFFFF);
		}
		if(GetDlgItem(IDC_NS_NIGHT_DOWN)->GetWindowTextLength())
		{
			GetDlgItem(IDC_NS_NIGHT_DOWN)->GetWindowText(buffer,20);
			app_prefs->SetNSNightDownload((atoi(buffer)) ? atoi(buffer) : 0xFFFF);
		}
		theApp.uploadqueue->NSNightUploadCheck();

		if (m_nsdtime.GetCurSel() != CB_ERR){
			app_prefs->SetNSEnd(m_nsdtime.GetItemData(m_nsdtime.GetCurSel()));
		}
		if (m_nsntime.GetCurSel() != CB_ERR){
			app_prefs->SetNSStart(m_nsntime.GetItemData(m_nsntime.GetCurSel()));
		}

		app_prefs->SetNSExceptSat((int8)IsDlgButtonChecked(IDC_NS_EXCEPT_SAT));
		app_prefs->SetNSExceptSun((int8)IsDlgButtonChecked(IDC_NS_EXCEPT_SUN));
		app_prefs->SetNSEnabled((int8)IsDlgButtonChecked(IDC_NS_ENABLED));

		app_prefs->SetMlDonkeyCM((int8)IsDlgButtonChecked(IDC_MLDONKEY_CM));

		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgAdvanced::Localize(void)
{
	if(m_hWnd){
		SetWindowText(GetResString(IDS_PW_ADVANCED));
		GetDlgItem(IDC_BAN)->SetWindowText(GetResString(IDS_BAN));
		GetDlgItem(IDC_CLIENTREQUESTLBL)->SetWindowText(GetResString(IDS_CLIENTREQUESTLBL));
		GetDlgItem(IDC_BANFORLABEL)->SetWindowText(GetResString(IDS_BANFORLABEL));
		GetDlgItem(IDC_TIMESINLBL)->SetWindowText(GetResString(IDS_TIMESINLBL));
		GetDlgItem(IDC_MINUTES_BAN1)->SetWindowText(GetResString(IDS_MINS));
		GetDlgItem(IDC_MINUTES_BAN2)->SetWindowText(GetResString(IDS_MINS));
		GetDlgItem(IDC_COM)->SetWindowText(GetResString(IDS_COM));
		GetDlgItem(IDC_COMENABLED)->SetWindowText(GetResString(IDS_ENABLED));
		GetDlgItem(IDC_NOBANENABLED)->SetWindowText(GetResString(IDS_NOBANENABLED));
		GetDlgItem(IDC_BANMESSAGE)->SetWindowText(GetResString(IDS_BANMESSAGE));
		GetDlgItem(IDC_SAVELOADSOURCESGROUPBOX)->SetWindowText(GetResString(IDS_SAVELOADSOURCESGROUPBOX));
		GetDlgItem(IDC_SLS_LOAD_QUANTITY)->SetWindowText(GetResString(IDS_SLS_LOAD_QUANTITY));
		GetDlgItem(IDC_SLS_LOAD_EVERY)->SetWindowText(GetResString(IDS_SLS_LOAD_EVERY));
		GetDlgItem(IDC_SLS_OUTDATED)->SetWindowText(GetResString(IDS_SLS_OUTDATED));
		GetDlgItem(IDC_SLS_MINS)->SetWindowText(GetResString(IDS_MINS));
		GetDlgItem(IDC_SLS_SOURCES)->SetWindowText(GetResString(IDS_SOURCES_PF_FILES));
		GetDlgItem(IDC_SLS_DAYS)->SetWindowText(GetResString(IDS_DAYS));
		GetDlgItem(IDC_SLSENABLED)->SetWindowText(GetResString(IDS_ENABLED));
		GetDlgItem(IDC_MLDONKEY_CM)->SetWindowText(GetResString(IDS_MLDONKEY_CM));

		GetDlgItem(IDC_NS_FRM)->SetWindowText(GetResString(IDS_NS_FRM));
		GetDlgItem(IDC_NS_DAY)->SetWindowText(GetResString(IDS_NS_DAY));
		GetDlgItem(IDC_NS_NIGHT)->SetWindowText(GetResString(IDS_NS_NIGHT));
		GetDlgItem(IDC_NS_KB1)->SetWindowText(GetResString(IDS_KBYTESEC));
		GetDlgItem(IDC_NS_KB2)->SetWindowText(GetResString(IDS_KBYTESEC));
		GetDlgItem(IDC_NS_TIME)->SetWindowText(GetResString(IDS_TIME));
		GetDlgItem(IDC_NS_UP)->SetWindowText(GetResString(IDS_NS_UP));
		GetDlgItem(IDC_NS_DOWN)->SetWindowText(GetResString(IDS_NS_DOWN));
		GetDlgItem(IDC_NS_DOWN)->SetWindowText(GetResString(IDS_NS_DOWN));
		GetDlgItem(IDC_NS_EXCEPT)->SetWindowText(GetResString(IDS_NS_EXCEPT));
		GetDlgItem(IDC_NS_EXCEPT_SAT)->SetWindowText(GetResString(IDS_NS_EXCEPT_SAT));
		GetDlgItem(IDC_NS_EXCEPT_SUN)->SetWindowText(GetResString(IDS_NS_EXCEPT_SUN));
	}
}

void CPPgAdvanced::OnBnClickedComEnabled()
{
	GetDlgItem(IDC_COMSTRING)->EnableWindow(IsDlgButtonChecked(IDC_COMENABLED));
	GetDlgItem(IDC_NOBANENABLED)->EnableWindow(IsDlgButtonChecked(IDC_COMENABLED));

	SetModified();
}

void CPPgAdvanced::OnBnClickedSLSEnabled()
{
	GetDlgItem(IDC_RESTORE_SOURCES_TIME)->EnableWindow(IsDlgButtonChecked(IDC_SLSENABLED));	
	GetDlgItem(IDC_LOAD_QUANTITIES)->EnableWindow(IsDlgButtonChecked(IDC_SLSENABLED));	
	GetDlgItem(IDC_OUTDATED)->EnableWindow(IsDlgButtonChecked(IDC_SLSENABLED));	

	SetModified();
}

void CPPgAdvanced::OnBnClickedNSEnabled()
{
	GetDlgItem(IDC_NS_DAY_TIME)->EnableWindow(IsDlgButtonChecked(IDC_NS_ENABLED));
	GetDlgItem(IDC_NS_DAY_UP)->EnableWindow(IsDlgButtonChecked(IDC_NS_ENABLED));
	GetDlgItem(IDC_NS_DAY_DOWN)->EnableWindow(IsDlgButtonChecked(IDC_NS_ENABLED));
	GetDlgItem(IDC_NS_NIGHT_TIME)->EnableWindow(IsDlgButtonChecked(IDC_NS_ENABLED));
	GetDlgItem(IDC_NS_NIGHT_UP)->EnableWindow(IsDlgButtonChecked(IDC_NS_ENABLED));
	GetDlgItem(IDC_NS_NIGHT_DOWN)->EnableWindow(IsDlgButtonChecked(IDC_NS_ENABLED));
	GetDlgItem(IDC_NS_EXCEPT_SAT)->EnableWindow(IsDlgButtonChecked(IDC_NS_ENABLED));
	GetDlgItem(IDC_NS_EXCEPT_SUN)->EnableWindow(IsDlgButtonChecked(IDC_NS_ENABLED));


	SetModified();
}
