// PPgMessaging.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgMessaging.h"


// CPPgMessaging dialog

IMPLEMENT_DYNAMIC(CPPgMessaging, CPropertyPage)
CPPgMessaging::CPPgMessaging()
	: CPropertyPage(CPPgMessaging::IDD) {
	LoadSettings();
	Localize();
}

CPPgMessaging::~CPPgMessaging() {
}

void CPPgMessaging::DoDataExchange(CDataExchange* pDX) {
	CPropertyPage::DoDataExchange(pDX);
}

void CPPgMessaging::Localize(void) {
	if(m_hWnd){
		SetWindowText(GetResString(IDS_PW_IM_OPTIONS));
		GetDlgItem(IDC_GB_IM_ACCEPT)->SetWindowText(GetResString(IDS_PW_IM_ACCEPT));
		GetDlgItem(IDC_GB_IM_OTHER)->SetWindowText(GetResString(IDS_PW_IM_OTHER));
		GetDlgItem(IDC_RB_IM_FROMALLUSERS)->SetWindowText(GetResString(IDS_PW_IM_FROMALLUSERS));
		GetDlgItem(IDC_RB_IM_ONLYFROMFRIENDS)->SetWindowText(GetResString(IDS_PW_IM_ONLYFROMFRIENDS));
		GetDlgItem(IDC_RB_IM_ONLYFROMFRIENDS2)->SetWindowText(GetResString(IDS_PW_IM_ONLYFROMFRIENDS2));
		GetDlgItem(IDC_RB_IM_FROMNONE)->SetWindowText(GetResString(IDS_PW_IM_FROMNONE));
		GetDlgItem(IDC_CB_IM_PUTMEAWAY)->SetWindowText(GetResString(IDS_PW_IM_PUTMEAWAY));
		GetDlgItem(IDC_LBL_IM_AWAYMESSAGE)->SetWindowText(GetResString(IDS_PW_IM_AWAYMESSAGE));
		GetDlgItem(IDC_FILTERLABEL)->SetWindowText(GetResString(IDS_FILTERLABEL));
		GetDlgItem(IDC_MSG)->SetWindowText(GetResString(IDS_CW_MESSAGES));
	}
}

void CPPgMessaging::LoadSettings(void) {
	CEdit* editPtr;
	if(m_hWnd)
	{
		switch(app_prefs->GetAcceptMessagesFrom()) {
			case 1: //Accept messages from all users
				CheckDlgButton(IDC_RB_IM_FROMALLUSERS, BST_CHECKED);				
				break;
			case 2: //Accept messages from friends only
				CheckDlgButton(IDC_RB_IM_ONLYFROMFRIENDS, BST_CHECKED);
				break;
			case 3: //Accept messages from friends and put other user's messages
				    //all in one tab
				CheckDlgButton(IDC_RB_IM_ONLYFROMFRIENDS2, BST_CHECKED);
				break;
			case 4: //Accept no message
				CheckDlgButton(IDC_RB_IM_FROMNONE, BST_CHECKED);
				break;
		}//switch acceptMessagesFrom

		if (app_prefs->GetAwayState())
				CheckDlgButton(IDC_CB_IM_PUTMEAWAY, BST_CHECKED);

		editPtr = (CEdit*) GetDlgItem(IDC_EDIT_IM_AWAYMESSAGE);
		editPtr->SetWindowText(app_prefs->GetAwayStateMessage());

		editPtr->EnableWindow(IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY));

		GetDlgItem(IDC_FILTER)->SetWindowText(app_prefs->GetMessageFilter());		
	}
}

BEGIN_MESSAGE_MAP(CPPgMessaging, CPropertyPage)
	ON_BN_CLICKED(IDC_RB_IM_FROMALLUSERS, OnBnClickedRbImFromallusers)
	ON_BN_CLICKED(IDC_RB_IM_ONLYFROMFRIENDS, OnBnClickedRbImOnlyfromfriends)
	ON_BN_CLICKED(IDC_RB_IM_ONLYFROMFRIENDS2, OnBnClickedRbImOnlyfromfriends2)
	ON_BN_CLICKED(IDC_RB_IM_FROMNONE, OnBnClickedRbImFromnone)
	ON_BN_CLICKED(IDC_CB_IM_PUTMEAWAY, OnBnClickedCbImPutmeaway)
	ON_EN_CHANGE(IDC_EDIT_IM_AWAYMESSAGE, OnEnChangeEditImAwaymessage)
END_MESSAGE_MAP()


// CPPgMessaging message handlers

BOOL CPPgMessaging::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPPgMessaging::OnApply() {
	CString buffer;

	if (IsDlgButtonChecked(IDC_RB_IM_FROMALLUSERS))
		app_prefs->SetAcceptMessagesFrom(1); // Accept all messages

	if (IsDlgButtonChecked(IDC_RB_IM_ONLYFROMFRIENDS))
		app_prefs->SetAcceptMessagesFrom(2); // Accept from friends

	if (IsDlgButtonChecked(IDC_RB_IM_ONLYFROMFRIENDS2))
		app_prefs->SetAcceptMessagesFrom(3); // Accept from friends and put other msg in a single tab

	if (IsDlgButtonChecked(IDC_RB_IM_FROMNONE))
		app_prefs->SetAcceptMessagesFrom(4); // Do not accept messages
	
	app_prefs->SetAwayState(IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY));

	GetDlgItem(IDC_EDIT_IM_AWAYMESSAGE)->GetWindowText(buffer);
	app_prefs->SetAwayStateMessage(buffer);

	GetDlgItem(IDC_FILTER)->GetWindowText(buffer);
	app_prefs->SetMessageFilter(buffer);

	SetModified(FALSE);
	return CPropertyPage::OnApply();
}

void CPPgMessaging::OnBnClickedCbImPutmeaway() {
	CEdit* editPtr;
	editPtr = (CEdit*) GetDlgItem(IDC_EDIT_IM_AWAYMESSAGE);
	editPtr->EnableWindow(IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY));
	if (IsDlgButtonChecked(IDC_CB_IM_PUTMEAWAY)) editPtr->SetFocus();
	SetModified();
}