// PPgWindow.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgWindow.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgWindow dialog

IMPLEMENT_DYNAMIC(CPPgWindow, CPropertyPage)
CPPgWindow::CPPgWindow()
	: CPropertyPage(CPPgWindow::IDD)
{
}

CPPgWindow::~CPPgWindow()
{
}

void CPPgWindow::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_USEDFONT, m_FontCombo);
	DDX_Control(pDX, IDC_USEDFONTSIZE, m_FontSize);
}

BEGIN_MESSAGE_MAP(CPPgWindow, CPropertyPage)
	ON_BN_CLICKED(IDC_STARTMIN, OnEnChangeStartMin)
	ON_BN_CLICKED(IDC_MINTRAY, OnBnClickedMintray)
	ON_BN_CLICKED(IDC_EXIT, OnBnClickedExit)
	ON_BN_CLICKED(IDC_BRINGTOFOREGROUND, OnBnClickedBringtoforeground)
	ON_BN_CLICKED(IDC_CB_TBN_CLOSETOTRAY, OnBnClickedCbTbnClosetotray)
	ON_CBN_SELCHANGE(IDC_USEDFONT, OnCbnSelchangeUsedFont)
	ON_CBN_SELCHANGE(IDC_USEDFONTSIZE, OnCbnSelchangeUsedfontsize)
	ON_BN_CLICKED(IDC_ED2KFIX, OnBnClickedEd2kfix)
	ON_BN_CLICKED(IDC_AUTOTAKEED2KLINKS, OnBnClickedAutoTakeED2KLinks)
	ON_BN_CLICKED(IDC_SHOWRATEONTITLE, OnBnClickedShowRateOnTitle)
END_MESSAGE_MAP()

BOOL CPPgWindow::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_FontCombo.m_style = CFontPreviewCombo::NAME_ONLY;
	m_FontCombo.Init();

	m_FontSize.AddString("8");
	m_FontSize.AddString("10");
	m_FontSize.AddString("12");
	GetDlgItem(IDC_ED2KFIX)->EnableWindow(Ask4RegFix(true));
	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgWindow::LoadSettings(void)
{
	if(app_prefs->GetStartMinimized())
		CheckDlgButton(IDC_STARTMIN,1);
	else
		CheckDlgButton(IDC_STARTMIN,0);

	if(app_prefs->DoMinToTray())
		CheckDlgButton(IDC_MINTRAY,1);
	else
		CheckDlgButton(IDC_MINTRAY,0);

	if(app_prefs->IsConfirmExitEnabled())
		CheckDlgButton(IDC_EXIT,1);
	else
		CheckDlgButton(IDC_EXIT,0);

	if(app_prefs->IsBringToFront())
		CheckDlgButton(IDC_BRINGTOFOREGROUND,1);
	else
		CheckDlgButton(IDC_BRINGTOFOREGROUND,0);

	if(app_prefs->GetCloseToTray())
		CheckDlgButton(IDC_CB_TBN_CLOSETOTRAY,1);
	else
		CheckDlgButton(IDC_CB_TBN_CLOSETOTRAY,0);

	// Barry
	if(app_prefs->AutoTakeED2KLinks())
		CheckDlgButton(IDC_AUTOTAKEED2KLINKS,1);
	else
		CheckDlgButton(IDC_AUTOTAKEED2KLINKS,0);

	if(app_prefs->ShowRatesOnTitle())
		CheckDlgButton(IDC_SHOWRATEONTITLE,1);
	else
		CheckDlgButton(IDC_SHOWRATEONTITLE,0);

	int FontIdx = m_FontCombo.FindStringExact(0,app_prefs->GetUsedFont());
	if(FontIdx == LB_ERR)
       m_FontCombo.SetCurSel(0);
	else
       m_FontCombo.SetCurSel(FontIdx);
	m_FontSize.SetCurSel(0);
	if (app_prefs->GetFontSize())
		m_FontSize.SetCurSel((int)((app_prefs->GetFontSize()-80)/20)); // FontSize Cax2

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgWindow::OnApply()
{
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{

		int8 mintotray_old = app_prefs->DoMinToTray(); // #zegzav (add)  

		app_prefs->SetStartMinimized((int8)IsDlgButtonChecked(IDC_STARTMIN));
		app_prefs->SetMinToTray((int8)IsDlgButtonChecked(IDC_MINTRAY));
		app_prefs->SetConfirmExitEnabled((int8)IsDlgButtonChecked(IDC_EXIT));
		app_prefs->SetBringToFront((int8)IsDlgButtonChecked(IDC_BRINGTOFOREGROUND));
		app_prefs->SetCloseToTray((int8)IsDlgButtonChecked(IDC_CB_TBN_CLOSETOTRAY));
		app_prefs->SetAutoTakeED2KLinks((int8)IsDlgButtonChecked(IDC_AUTOTAKEED2KLINKS)); // DonGato
		app_prefs->SetRatesOnTitle(IsDlgButtonChecked(IDC_SHOWRATEONTITLE));

		// #zegzav
        if (mintotray_old != (int8)app_prefs->DoMinToTray()) {
            theApp.emuledlg->TraySetMinimizeToTray((int8)app_prefs->DoMinToTray());
    		theApp.emuledlg->TrayMinimizeToTrayChanged();
        }
   
		CString buffer;
		m_FontCombo.GetWindowText(buffer);
		app_prefs->SetUsedFont(buffer);
		app_prefs->SetFontSize(m_FontSize.GetCurSel()*20 + 80);	// FontSize Cax2
		// Cax2 - Font update
		theApp.emuledlg->m_DefaultFont.DeleteObject(); 
		theApp.emuledlg->m_DefaultFont.CreatePointFont(app_prefs->GetFontSize(),buffer); 
      	theApp.emuledlg->serverwnd.InitFont(); 
      	theApp.emuledlg->ircwnd.InitFont(); 
      	theApp.emuledlg->chatwnd.chatselector.chatout.SetFont(&theApp.emuledlg->m_DefaultFont); 

		SetModified(FALSE);

		if (!theApp.glob_prefs->ShowRatesOnTitle()) {
			char buffer[50];
			sprintf(buffer,"eMule Plus v%s",CURRENT_VERSION_LONG);
			theApp.emuledlg->SetWindowText(buffer);
		}
	}

	return CPropertyPage::OnApply();
}

void CPPgWindow::Localize(void)
{
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_WINDOW));
		GetDlgItem(IDC_STARTMIN)->SetWindowText(GetResString(IDS_PREF_STARTMIN));	
		GetDlgItem(IDC_MINTRAY)->SetWindowText(GetResString(IDS_PW_TRAY));
		GetDlgItem(IDC_EXIT)->SetWindowText(GetResString(IDS_PW_PROMPT));
		GetDlgItem(IDC_BRINGTOFOREGROUND)->SetWindowText(GetResString(IDS_PW_FRONT));
		GetDlgItem(IDC_CB_TBN_CLOSETOTRAY)->SetWindowText(GetResString(IDS_PW_TBN_CLOSETOTRAY));
		GetDlgItem(IDC_USEDFONT_LBL)->SetWindowText(GetResString(IDS_USEDFONT_LBL));
		GetDlgItem(IDC_ED2KFIX)->SetWindowText(GetResString(IDS_ED2KLINKFIX));
		GetDlgItem(IDC_AUTOTAKEED2KLINKS)->SetWindowText(GetResString(IDS_AUTOTAKEED2KLINKS));
		GetDlgItem(IDC_SHOWRATEONTITLE)->SetWindowText(GetResString(IDS_SHOWRATEONTITLE));
	}
}

void CPPgWindow::OnBnClickedEd2kfix()
{
	Ask4RegFix(false);
	GetDlgItem(IDC_ED2KFIX)->EnableWindow(Ask4RegFix(true));
}
